#!/bin/sh

if [ -z "$1" ]; then
	CDROMFILE=".tuxum_bootcd stage2.squashfs"
else
	CDROMFILE="$1"
fi

if [ -z "$2" ]; then
	CDTYPE=tuxum
else
	CDTYPE="$2"
fi

for i in iso9660 vfat ntfs ext2 cdrom ahci sr_mod sd_mod scsi_mod
do
	modprobe $i 2>/dev/null
done

# create new nodes (delayed USB-CDROM, a new CDROM...)
cd /sys/block 
for i in $( ls ); do
	if [ ! -e "/dev/$i" ]; then
		cd /sys/block/$i
		mknod /dev/$i b $( cat dev | sed "s/:/ /g" )
		for j in $i*; do
			if [ -d "$j" ]; then
				cd /sys/block/$i/$j
				mknod /dev/$j b $( cat dev | sed "s/:/ /g" )
				cd /sys/block/$i
			fi
		done
	fi
done

cd /sys/block/
for i in *; do
	cd /sys/block/$i
	removable=$( cat removable )
	#echo "try " $i, $removable
	#if [ "$removable" == 1 ]; then   ## now allowed even in non removables (usb...)...
	donttry=`echo $i | grep "nbd\|loop\|ram"`
	if [ -z "$donttry" ]; then
		mount -t iso9660 -o ro /dev/$i /cdrom 2> /dev/null
		if [ $? == 0 ]; then
			for fle in $CDROMFILE; do
				if [ -e /cdrom/$fle ]; then
					echo "/dev/$i	/cdrom	iso9660	defaults,ro,user,noauto	0	0" >> /tmp/fstab
					rm -f /dev/cdrom
					ln -s /dev/$i /dev/cdrom
					echo
					echo "Found $CDTYPE CD/DVD cdrom at $i"
					exit 0
				fi
			done
			umount /cdrom 2> /dev/null
		fi
	fi

		# maybe a pendrive or external hd?
		for j in [ $i* ]; do
			if [ -d "$j" ]; then
				#echo "check " $j
				mount -t vfat -o ro /dev/$j /cdrom 2> /dev/null && FS=vfat
				mount -t ext2 -o ro /dev/$j /cdrom 2> /dev/null && FS=ext2
				mount -t ntfs -o ro /dev/$j /cdrom 2> /dev/null && FS=ntfs
	
				for fle in $CDROMFILE; do
					if [ -e /cdrom/$fle ]; then
						echo "/dev/$j	/cdrom	$FS	defaults,ro,user,noauto	0	0" >> /tmp/fstab
						rm -f /dev/cdrom
						ln -s /dev/$j /dev/cdrom
						echo
						echo "Found $CDTYPE CD/DVD $FS at $j"
						exit 0
					fi
				done
				umount /cdrom 2> /dev/null 
			fi
		done
	#fi
	cd ..
done

exit 1

