mkdir stage2
pushd stage2 > /dev/null

message "Prepare stage2... (${FILEPACKAGES})"

mkdir initrd

mkdir proc
mkdir sys
mkdir etc
mkdir tmp
mkdir cdrom
mkdir mnt
mkdir target
mkdir -p var/lib

. cp_packages.sh ${FILEPACKAGES}

if [ $? != "0" ] ; then
	error "Error preparing stage2"
	exit 2
fi

popd > /dev/null

message "Generating squashfs image.. please wait. It may take long."
mksquashfs stage2 ${ISO}/stage2.squashfs > /dev/null
if [ $? != '0' ]; then
	error "Cant generate squashfs image"
	exit 2
fi

SIZE=$( du -h ${ISO}/stage2.squashfs | awk '{ print $1 }' )

message_ok "stage2.squashfs ready ($SIZE)"

